%% Code for Day 7 (No Instructor Present)

% Add path to EEGLab and launch EEGLab before we begin (or use your
% shortcut on the shortcuts bar)

% Make sure you can access your sample data (sampleEEGdata.mat)
load('..\sampleEEGdata.mat'); % change directory as needed

%% ---------------------------------------------------------
% Updated and Expanded Integration and comparison ASSIGNMENT
% ----------------------------------------------------------
    % First, complete the prior Assignment;  If you get stuck, see the Code
    % with Answers from Day6 to get you ; see also the code from Day 6 for
    % stfft and multitaper
    
    % FINISH PRIOR ASSIGNMENT: Compare STFFT, Filter-Hilbert, Wavelet, and MultiTaper --------------
    % Select one electrode, and one frequency 
    % Compute power over time at that electrode and that frequency using:
    %  Complex wavelet convolution
    %  Filter-Hilbert
    %  Short-time FFT
    %  Multi-taper
    % Create a subplot with 5 rows and plot the ERP (average of raw signal) in the first subplot
    %   and then the power time series results of these four time-frequency decomposition 
    %   in the subsequent four subplots -- and put a title on each!
    % How visually similar are the results from these methods?
    % Repeat for a very different frequency (far away from the one you chose)
    % Do the methods converge more for higher or lower frequencies?

    %% Use these again and again
        channel2use = 'Pz';  % Pick any vallid channel name
        channel2use_idx = strcmpi(channel2use,{EEG.chanlocs.labels});
        freq2use = 17.2;  % What's your favorite frequency?
        time_limits = [-300 800]; % we have long epochs so we'll get rid of edge effects

    %% Make ERP
        
    
        ERP_times = @@    % times that will be plotted for ERP
        ERP_Average= @@   % the ERP signal for a single channel "channel2 use"
    %% Wavelet approach 
        
    
        wavelet_times = @@  % times that will be plotted for wavelet power
        wavelet_power = @@  % the wavelet power time series a single channel "channel2 use" and single frequency "freq2use"

        
    %% Filter-Hilbert -- can you use what you created above in the first Assignment?
        
        
        hilbert_times = @@  % times that will be plotted for Hilbert power
        hilbert_power = @@  % the Hilbert power time series a single channel "channel2 use" and single frequency "freq2use"
        
    %%  Short-time FFT -- can you see what stfft can do for you?
    
    
        db_shortFFT_tf_times = @@  % times that will be plotted for stfft power
        db_shortFFT_tf_power = @@  % the stfft power time series a single channel "channel2 use" and single frequency "freq2use"
        
       
        
    %%  Multi-taper

    
        MultiTaper_times = @@  % times that will be plotted for Multi-taper power
        MultiTaper_power = @@  % the Multi-taperpower time series a single channel "channel2 use" and single frequency "freq2use"
        
    %% Plot it all!  Be sure to have times on X axis; 
    % Create a subplot with 5 rows and plot the ERP (average of raw signal) in the first subplot
    %   and then the power time series results of these four time-frequency decomposition 
    %   in the subsequent four subplots -- and put a title on each!
    % Bonus: link x axes across subplots
    % How visually similar are the results from these methods?


    %% Repeat for a very different frequency (far away from the one you chose)
    %  Do the methods converge more for higher or lower frequencies?
    
    
%% -----------------------------------------------------------------
% ASSIGNMENT: Make the plots looks more similar to one another
% ------------------------------------------------------------------
% Can you tweak various parameters for the various methods to make the
% results more comparable across methods?  
% For example, you can tweak (among others):
%   The number of cycles in the waelet
%   The length of the filter for filter-hilbert (see doc optFIR)
%   The length of the window for the stfft, and the nuber of points in the FFT for the stfft
%   The number of tapers for multitaper, and the number of points in the  FFT for the multi-taper


%% -----------------------------------------------------------------
% ASSIGNMENT: Expanding the previous assignment to a frequency band
% ------------------------------------------------------------------
% You've now compared these methods for a single frequency (well, actually
% a small frequency band centered on the frequency you specified)
%
% Now choose a frequency band (e.g., 8 to 13 Hz) and compare the four
% methods as you did above
%
% Some hints:
%   You'll need to sum the power of one or more wavelet power time-series to get the power for more than one frequency
%   Filter-Hilbert is easy since you define the band with your filter
%   For both multi-taper and stfft you'll need to also sum the power across  one or more power time-series
% 
% Plot the results as above in the 5 subplots
% How comparable are the approaches for a frequency band
% 
% Repeat for a very different frequency (far away from the one you chose)
% Do the methods converge more for higher or lower frequencies



%% -----------------------------------------------------------------
% SUPER BONUS ASSIGNMENT: Topographical mapping of the methods
% ------------------------------------------------------------------
% This is clearly an advanced assignment for those of you who like a good
% challenge, or have the programming bug and no place to go over spring
% break
%
% Instead of creating the Time-Frequency decompostion for just one channel,
% create it for all channels.  You will have a channels by timeoints matrix
% that has the power timeseries at the frequency you chose.
%
% Now choose several times (e.g., 0, 100, 200, 300, 400, 500 msec) and plot
% the power at those timepoints on separate topoplots.
% Hint: Look back to when we used the topoplot function in Day 3
%
% Repeat for another frequency

